% Newsvendor Model

% pc=input('Enter the purchase cost: ');
% sp=input('Enter the selling price: ');
% sv=input('Enter the salvage value: ');
% sc=input('Enter the shortage cost: ');
% m_d=input('Enter the mean value of the demand: ');
% sd_d=input('Enter the standard deviation of the demand: ');
% r=input('Enter the number of simulation runs: ');
% iv=input('Enter the increment value by which the quantity will vary: ');
% stream = RandStream('mrg32k3a');
% RandStream.setDefaultStream(stream);
% stream.Substream = 1;
pc=0.35;
sp=0.45;
sv=0.05;
sc=0.3;
m_d=30;
sd_d=6.2;
r=1000;
iv=1;

q=[];
q(1)=m_d-(3*sd_d);
avg_profit=[];
j=1;
while q(j)<=(m_d+(3*sd_d))
    sum=0;
    for u=1:r
        z=normrnd(m_d,sd_d);
        if z<q(j)
            profit=(sp * z) + (sv * (q(j) - z)) - (pc * q(j));
        else
            profit=(sp * q(j))-(pc * q(j))-(sc*(z - q(j)));
        end
        sum=sum+profit;
    end
    avg_profit(j)=sum/r;  %#ok<SAGROW>
    j=j+1;
    q(j)=q(j-1)+iv;
end
[max_profit,q_no]=max(avg_profit);
q_max=q(q_no);
l_q=size(q,2);
q(l_q)=[];
figure(1)
plot(q,avg_profit,'--rs','LineWidth',2,'MarkerEdgeColor','k','MarkerFaceColor','g','MarkerSize',4)    
xlabel('Quantity')
ylabel('Profit')
title('Plot of Profit vs Quantity for Newsvendor Model')
